/*****************************************************************************/
/*																			 */
/* fichier	: moteur.h									version : V2.4		 */
/* projet	: moteur									date :	03/02/2005	 */
/* par		: aerith														 */
/*																			 */
/* mini moteur 3D															 */
/*																			 */
/*****************************************************************************/

#include	<string.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<math.h>
#include	<time.h>
#include	<SDL\SDL.h>

#define		NBCARLINE	1024

typedef struct {
	float	x;
	float	y;
	float	z;
} vecteur;

typedef struct {
	vecteur v3D;
	vecteur v2D;
} vertex;

typedef struct {
	float	x;
	float	y;
	float	w;
	float	h;
} rect;

typedef struct {
	int		a;
	int		b;
	int		c;
	vecteur centre;
	vecteur normal;
	int		dist;
	rect	out;
} face;

typedef struct {
	float	x;
	float	y;
	float	z;
	float	a;
} quaternion;

typedef struct {
	int		i;
	int		r;
	int		g;
	int		b;
} light;

typedef struct {
	float	Zoom;		/* <n> */
	float	Cliping;	/* <n> */
	vecteur Camera;		/* <x> <y> <z> */
	quaternion Rotate;	/* <a> <x> <y> <z> */
	int		Light;		/* <0|1> */
	light	Lcolor;		/* <intensitee> <r> <g> <b> */
	int		Render;		/* <planar 0|wireframe 1|dot 2> */
	int		Allface;	/* <0|1> */
	int		WindowX;	/* <n> */
	int		WindowY;	/* <n> */
	int		Color;		/* <16|32> */
	char	Title[256];	/* <text> */
	int		Triface;	/* <0|1> */
} option;

typedef struct {
	vertex 	*Vertex;
	face	*Faces;
	int		NumVertex;
	int		NumFace;
} mesh;


void	Load(char *pFichier, mesh *pMesh);
void	Init(char *pFichier, option *pOption);
void	Render(mesh *pMesh, option *pOption);

int  	Round(float fData);
void 	CopyVect(vecteur *Out, vecteur In);
float	getmax(float a, float b, float c);
float	getmin(float a, float b, float c);
char 	*gettok(const char *pData, int iPos, char *pCar);
void	Point(vecteur p1, int r, int g, int b);
void	Line(vecteur p1, vecteur p2, int r, int g, int b);
void	Triangle(vecteur p1, vecteur p2, vecteur p3, int r, int g, int b);

