/*****************************************************************************/
/*																			 */
/* fichier	: test.c									version : V2.4		 */
/* projet	: moteur									date :	16/12/2005	 */
/* par		: aerith														 */
/*																			 */
/* test pour le mini moteur 3D												 */
/*																			 */
/*****************************************************************************/

#include	"moteur.h"

int main (int argc, char **argv)
{
	mesh		Mesh;
	option		Option;
	float		p = 1;
	float		ap = (float)0.025;
	float		zp = 1;
	float		cp = 1;
	int			done = 0;
	SDL_Event 	event;
	Uint8		*keys;
	FILE		*Fichier;
	char		Data[NBCARLINE];
	int			autolook = 0;

	Init("m3d.init", &Option);

	Fichier = fopen("m3d.map", "r");
	if(!Fichier)
	{
		perror("erreur m3d.map non trouver\n");
		exit(1);
	}

	while(!feof(Fichier))
		fgets(Data, NBCARLINE, Fichier);

	fclose(Fichier);

	Load(Data, &Mesh);

	while(!done)
	{
		while(SDL_PollEvent(&event))
		{
			if(event.type == SDL_QUIT)
				done = 1;
		}

		if(!autolook)
		{
			Option.Rotate.a = 0;
			Option.Rotate.x = 0;
			Option.Rotate.y = 0;
			Option.Rotate.z = 0;
		}

		keys = SDL_GetKeyState(NULL);

		if(keys[SDLK_LSHIFT])	/* shift gauche : auto look */
		{
			if(autolook == 1)
				autolook = 0;
			else
				autolook = 1;
		}

		if(keys[SDLK_UP])		/* haut : tz- */
			Option.Camera.z -= p;
		if(keys[SDLK_DOWN])		/* bas : tz+ */
			Option.Camera.z += p;
		if(keys[SDLK_RIGHT])	/* droite : tx- */
			Option.Camera.x -= p;
		if(keys[SDLK_LEFT])		/* gauche : tx+ */
			Option.Camera.x += p;
		if(keys[SDLK_RCTRL])	/* ctrl droit : ty- */
			Option.Camera.y -= p;
		if(keys[SDLK_RSHIFT])	/* shift droit : ty+ */
			Option.Camera.y += p;

		if(keys[SDLK_KP2])		/* 2 : rx- */
		{
			Option.Rotate.a = -ap;
			Option.Rotate.x = 1;
			Option.Rotate.y = 0;
			Option.Rotate.z = 0;
		}
		if(keys[SDLK_KP8])		/* 8 : rx+ */
		{
			Option.Rotate.a = ap;
			Option.Rotate.x = 1;
			Option.Rotate.y = 0;
			Option.Rotate.z = 0;
		}
		if(keys[SDLK_KP4])		/* 4 : ry- */
		{
			Option.Rotate.a = -ap;
			Option.Rotate.x = 0;
			Option.Rotate.y = 1;
			Option.Rotate.z = 0;
		}
		if(keys[SDLK_KP6])		/* 6 : ry+ */
		{
			Option.Rotate.a = ap;
			Option.Rotate.x = 0;
			Option.Rotate.y = 1;
			Option.Rotate.z = 0;
		}
		if(keys[SDLK_KP1])		/* 1 : rz+ */
		{
			Option.Rotate.a = ap;
			Option.Rotate.x = 0;
			Option.Rotate.y = 0;
			Option.Rotate.z = 1;
		}
		if(keys[SDLK_KP3])		/* 3 : rz- */
		{
			Option.Rotate.a = -ap;
			Option.Rotate.x = 0;
			Option.Rotate.y = 0;
			Option.Rotate.z = 1;
		}

		if(keys[SDLK_KP_PLUS])		/* + : zoom+ */
			Option.Zoom += zp;
		if(keys[SDLK_KP_MINUS])		/* - : zoom- */
			Option.Zoom -= zp;
		if(keys[SDLK_KP_DIVIDE])	/* / : clip+ */
			Option.Cliping += cp;
		if(keys[SDLK_KP_MULTIPLY])	/* * : clip- */
			Option.Cliping -= cp;

		Render(&Mesh, &Option);
	}

	return 0;
}
